<?php

namespace App\Services\Auth;

use App\Entities\UserEntity;
use App\Helpers\UserHelper;
use App\Models\UserModel;
use App\Libraries\MySocket\GoogleSocket\CURL;
use CodeIgniter\Exceptions\PageNotFoundException;

class GoogleService extends AuthService
{
	private $_mySocket = null;
	public function __construct(mixed $mySocket)
	{
		$this->_mySocket = $mySocket;
		parent::__construct(new UserModel(), new UserHelper());
		$this->addClassName('Google');
	}
	public function getMySocket(): mixed
	{
		if (!$this->_mySocket) {
			throw new \Exception("Socket이 지정되지 않았습니다.");
		}
		return $this->_mySocket;
	}
	public function getFormFields(): array
	{
		return ["access_code"];
	}
	public function getFormFilters(): array
	{
		return ["access_code"];
	}
	public function getBatchjobButtons(): array
	{
		return [];
	}
	//기본기능
	public function login(array $formDatas): UserEntity
	{
		try {
			// Google 서비스 설정
			$this->getMySocket()->setToken($formDatas['access_code']);
			$sns_entity = $this->_mySocket->signup();
			// local db 사용와의 연결 확인
			$entity = $this->getEntity($sns_entity->getParent());
			if (!$entity instanceof UserEntity) {
				throw new PageNotFoundException("회원[{$sns_entity->getTitle()}]님은 아직 로컬사용자 연결이 이루어지지 않았습니다.");
			}
			return $this->login_process($entity);;
		} catch (\Google_Service_Exception $e) {
			log_message('error', '구글 서비스 예외발생: ' . $e->getMessage());
			throw new PageNotFoundException("구글 로그인 중 오류가 발생했습니다. 다시 시도해 주세요.");
		} catch (\Exception $e) {
			log_message('error', $e->getMessage());
			throw new PageNotFoundException("관리자에게 문의하시기 바랍니다.\n{$e->getMessage()}");
		}
	}
}
